> For the complete documentation index, see [llms.txt](https://docs.tailent.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.tailent.com/scripting-utility-classes/common-scripts-repository/c-scripts-repository/read-excel.md).

# Read Excel

This adds the first worksheet to an ExcelWorksheet variable, creates a loop based on the number of written rows in the excel document, getting the values and adding them to a list (List\<string> in the snipped below) with each iteration.

This script will require adding **using OfficeOpenXml;** to the namespaces section.

```csharp
ExcelWorksheet document = excelDocument.getWorkSheet(1);
int RowsCount = document.Dimension.End.Row; 

for (int j=1;j<=RowsCount;j++)
{
    string cellValue = document.Cells[j, 1].GetValue<string>();					          List<string>.Add(cellValue);}
    List<string>.Add(cellValue);
}
```

{% hint style="info" %}
The ExcelWorksheet variable has to be open using the “Open excel workbook” action before initializing the C# script, otherwise it will not be a valid reference to an Excel Workbook.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.tailent.com/scripting-utility-classes/common-scripts-repository/c-scripts-repository/read-excel.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
